package com.nabancard.testpayanywheresdk;

import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import java.math.BigDecimal;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * @author aahmed
 * @author mbolleddula
 */
public class MainActivity extends AppCompatActivity {
    private static final String TAG = "TestPayAnywhereSdk";

    private static final String PAYMENT_URL = "payanywhere://payment/";
    private static final String PREAUTH_URL = "payanywhere://preauth/";
    private static final String PREAUTH_COMPLETE_URL = "payanywhere://preauth_complete/";
    private static final String RECURRING_PAYMENT_UPDATE_URL = "payanywhere://recurring_payment_update/";
    private static final String RECURRING_PAYMENT_DEACTIVATE_URL = "payanywhere://recurring_payment_deactivate";
    private static final String TIPS_URL = "payanywhere://tips/";
    private static final String REFUND_URL = "payanywhere://refund/";
    private static final String VOID_URL = "payanywhere://void/";

    private static final String EXTRA_TRANSACTION_RESULT = "transactionResult";
    private static final String EXTRA_TRANSACTION_UNIQUE_ID = "transactionUniqueId";
    private static final String EXTRA_RECEIPT_ID = "receiptId";
    private static final String EXTRA_PARTIAL_AUTH = "isPartialAuth";
    private static final String EXTRA_REQUESTED_AMOUNT = "requestedAmount";
    private static final String EXTRA_AUTHORIZED_AMOUNT = "authorizedAmount";
    private static final String EXTRA_CUSTOMER_TRANSACTION_ID ="customerTransactionId";
    private static final String EXTRA_EXTERNAL_NOTIFICATION ="externalNotification";
    public static final String EXTRA_TRANSACTION_ACTION = "transactionAction";
    public static final String EXTRA_TRANSACTION_STATUS_MESSAGE = "transactionStatusMessage";
    public static final String EXTRA_RECURRING_PAYMENT_ID ="recurringPaymentId";
    public static final String EXTRA_RECURRING_PAYMENT_CCS_ID ="recurringPaymentCCSId";
    public static final String EXTRA_RECURRING_PERIOD ="recurringPeriod";
    public static final String EXTRA_RECURRING_LENGTH ="recurringLength";
    public static final String EXTRA_NETWORK = "network";
    public static final String EXTRA_LAST4 = "last4";
    public static final String EXTRA_HIDE_SEND_AS_INVOICE = "hideSendAsInvoice";
    public static final String EXTRA_RECEIPT_SCREEN_REQUIRED ="receiptScreen";
    private static final String EXTRA_SHOW_ACCEPT_CASH = "acceptCash";
    private static final String EXTRA_SHOW_ALIPAY = "showAlipay";
    public static final String EXTRA_SEND_BRIC = "sendBRIC";
    public static final String EXTRA_TRANSACTION_BRIC = "transactionBRIC";
    public static final String EXTRA_AUTH_CODE = "authCode";
    private static final String EXTRA_CC_DETAILS = "ccDetails";
    public static final String EXTRA_SIGN_ON_PRINT_RECEIPT = "signOnPaper";
    public static final String EXTRA_ALLOW_CATEGORY = "allowCategorySelection";
    public static String EXTRA_CANCEL_NOTIFICATION = "cancelNotification";
    public static String EXTRA_CLOSE_SDK_WHEN_DECLINE = "closeOnDecline";
    public static String EXTRA_AUTO_CANCEL_TIMEOUT = "autoCancelTimeout";
    public static final String EXTRA_PRIMARY_COLOR ="primaryColor";
    public static final String EXTRA_CONTRAST_COLOR ="contrastColor";
    private static String EXTRA_ITEM_NAME = "itemName";
    private static String EXTRA_RECEIPT_NOTES = "receiptNotes";
    private static String EXTRA_SHOW_TRANS_LIST = "showTransList";
    private static String EXTRA_SHOW_SIGNATURE_SCREEN = "showSignatureScreen";
    public static String
            EXTRA_FIRST_NAME = "firstName",
            EXTRA_LAST_NAME = "lastName",
            EXTRA_CUSTOMER_NAME = "customerName",
            EXTRA_EMAIL = "email",
            EXTRA_PHONE_NUMBER = "phoneNumber",
            EXTRA_INVOICE_NUMBER = "invoiceNumber",
            EXTRA_INVOICE_DUE = "invoiceDueDate",
            EXTRA_RI_START_DATE = "riStartDate",
            EXTRA_RI_END_DATE = "riEndDate",
            EXTRA_RI_LENGTH = "riLength",
            EXTRA_RI_PERIOD = "riPeriod";

    private static final int PAYMENT_REQUEST_CODE = 123;
    private static final int PREAUTH_REQUEST_CODE = 456;
    private static final int PREAUTH_COMPLETE_REQUEST_CODE = 789;
    private static final int TIPS_REQUEST_CODE = 555;
    private static final int REFUND_VOID_REQUEST_CODE = 369;
    private static final int RECURRING_PAYMENT_UPDATE_REQUEST_CODE = 227;
    private static final int RECURRING_PAYMENT_DEACTIVATE_REQUEST_CODE = 347;

    private static final String ITEM_NAME_PARAM = "&" + EXTRA_ITEM_NAME +"=";
    private static final String RECEIPT_NOTES_PARAM = "&" + EXTRA_RECEIPT_NOTES + "=";
    private static final String CUSTOMER_PROVIDED_ID_PARAM = "&" + EXTRA_CUSTOMER_TRANSACTION_ID +"=";
    private static final String INVOICE_NUMBER_PARAM = "&" + EXTRA_INVOICE_NUMBER +"=";
    private static final String EXTERNAL_NOTIFICATION_PARAM = "&" + EXTRA_EXTERNAL_NOTIFICATION + "=";
    private static final String REQUIRED_CC_DETAILS_PARAM = "&" + EXTRA_CC_DETAILS + "=";
    private static final String REQUIRED_RECEIPT_SCREEN_PARAM = "&" + EXTRA_RECEIPT_SCREEN_REQUIRED + "=";
    private static final String REQUIRED_SIGNATURE_ON_PAPER = "&" + EXTRA_SIGN_ON_PRINT_RECEIPT + "=";
    private static final String CANCEL_NOTIFICATION_PARAM = "&" + EXTRA_CANCEL_NOTIFICATION + "=";
    private static final String CLOSE_SDK_ON_DECLINE_PARAM = "&" + EXTRA_CLOSE_SDK_WHEN_DECLINE + "=";
    private static final String HIDE_SEND_AS_INVOICE_PARAM = "&" + EXTRA_HIDE_SEND_AS_INVOICE + "=";
    private static final String SHOW_ACCEPT_CASH_PARAM = "&" + EXTRA_SHOW_ACCEPT_CASH + "=";
    private static final String SHOW_ALIPAY_PARAM = "&" + EXTRA_SHOW_ALIPAY + "=";
    private static final String SEND_BRIC_PARAM = "&" + EXTRA_SEND_BRIC + "=";
    private static final String ALLOW_CATEGORY_PARAM = "&" + EXTRA_ALLOW_CATEGORY + "=";
    private static final String AUTO_CANCEL_TIMEOUT_PARAM = "&"+ EXTRA_AUTO_CANCEL_TIMEOUT + "=";
    private static final String PRIMARY_COLOR_PARAM = "&"+ EXTRA_PRIMARY_COLOR + "=";
    private static final String CONTRAST_COLOR_PARAM = "&"+ EXTRA_CONTRAST_COLOR + "=";
    private static final String SHOW_TRANS_LIST_PARAM = "&"+ EXTRA_SHOW_TRANS_LIST + "=";
    private static final String SHOW_SIGNATURE_SCREEN_PARAM = "&"+ EXTRA_SHOW_SIGNATURE_SCREEN + "=";

    @BindView(R.id.amountEditText) EditText mAmountEditText;
    @BindView(R.id.itemNameEditText) EditText mItemNameEditText;
    @BindView(R.id.receiptNotesET) EditText mReceiptNotesET;

    @BindView(R.id.recurringIdEditText) EditText mRecurringIdEditText;
    @BindView(R.id.recurringCCSIdEditText)EditText mRecurringCCSIdEditText;
    @BindView(R.id.recurringLengthEditText)EditText mRecurringLengthEditText;
    @BindView(R.id.recurringPeriodSpinner) Spinner mRecurringPeriodSpinner;
    @BindView(R.id.recurringCustomerFirstNameEditText)EditText mRecurringCustomerFirstEditText;
    @BindView(R.id.recurringCustomerLastNameEditText)EditText mRecurringCustomerLastEditText;
    @BindView(R.id.recurringCustomerEmailEditText)EditText mRecurringCustomerEmailEditText;

    @BindView(R.id.transactionActionUniqueIdEditText) EditText mTransactionActionUniqueIdEditText;
    @BindView(R.id.refundAmountEditText) EditText mRefundAmountEditText;
    @BindView(R.id.preAuthCompleteAmountEditText) EditText mPreAuthCompleteAmountEditText;
    @BindView(R.id.tipsAmountEditText) EditText mTipsAmountEditText;
    @BindView(R.id.receiptIdIdEditText) EditText mReceiptIdEditText;

    @BindView(R.id.receiptScreenDisabledCheckBox) CheckBox mReceiptScreenDisabledCheckBox;
    @BindView(R.id.signOnPaperCheckBox) CheckBox mSignOnPrintReceiptCheckBox;
    @BindView(R.id.externalNotificationCheckBox) CheckBox mExternalNotificationCheckBox;
    @BindView(R.id.requiredCardDetailsCheckBox) CheckBox mRequiredCardDetailsCheckBox;
    @BindView(R.id.cancelNotificationCheckBox) CheckBox mCancelNotificationCheckBox;
    @BindView(R.id.closeOnDeclineCheckBox) CheckBox mCloseSdkOnDeclineCheckBox;
    @BindView(R.id.hideSendAsInvoiceCheckBox) CheckBox mHideSendAsInvoiceCheckBox;
    @BindView(R.id.showAcceptCashCheckBox) CheckBox mShowAcceptCashCheckBox;
    @BindView(R.id.showAlipayCheckBox) CheckBox mShowAlipayCheckBox;
    @BindView(R.id.sendBRICCheckBox) CheckBox mSendBRICCheckBox;
    @BindView(R.id.allowCategoryCheckBox) CheckBox mAllowCategoryCheckBox;
    @BindView(R.id.showTransListCheckBox) CheckBox mShowTransListCheckBox;
    @BindView(R.id.signOnScreenCheckBox) CheckBox mShowSignatureScreenCheckBox;
    @BindView(R.id.customerProvideIdEditText) EditText mCustomerProvidedIdEditText;
    @BindView(R.id.invoiceNumberEditText) EditText mInvoiceNumberEditText;
    @BindView(R.id.autoCancelTimeoutEditText) EditText mAutoCancelTimeoutEditText;
    @BindView(R.id.primaryColorEditText) EditText mPrimaryColorEditText;
    @BindView(R.id.contrastColorEditText) EditText mContrastColorEditText;

    @BindView(R.id.responseEditText) EditText mResponseEditText;

    @BindView(R.id.versionTextView) TextView mVersionText;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        ButterKnife.bind(this);
        setUpViews();
    }

    private void setUpViews(){
        //generating random charge amount for easy testing
        double randomNumber = Math.random()/10;
        if(randomNumber == 0.00d){
            randomNumber = 0.03;
        }
        String randomChargeAmount = String.format("%.2f", randomNumber);
        mAmountEditText.setText(randomChargeAmount);

        //set version
        mVersionText.setText(getString(R.string.version_s, BuildConfig.VERSION_NAME, BuildConfig.VERSION_CODE + ""));
    }

    public void payButtonClicked(View view) {
        String chargeAmount = mAmountEditText.getText().toString();
        if(TextUtils.isEmpty(chargeAmount)){
            showToastMessage("Amount is Empty");
        } else{
            Intent intent = new Intent(Intent.ACTION_VIEW , Uri.parse(PAYMENT_URL +  "?chargeAmount=" + chargeAmount + getOtherPaymentsParam()));
            if(isPayAnywhereSdkInstalled(intent)){
                startActivityForResult(intent, PAYMENT_REQUEST_CODE);
            } else{
                showToastMessage("PayAnywhere Sdk is not Installed. Plz Install PayAnywhere SDK");
            }
        }
    }

    public void preAuthButtonClicked(View view) {
        String chargeAmount = mAmountEditText.getText().toString();
        if(TextUtils.isEmpty(chargeAmount)){
            showToastMessage("Amount is Empty");
        } else{
            Intent intent = new Intent(Intent.ACTION_VIEW , Uri.parse(PREAUTH_URL +  "?chargeAmount=" + chargeAmount + getOtherPaymentsParam()));
            if(isPayAnywhereSdkInstalled(intent)){
                startActivityForResult(intent, PREAUTH_REQUEST_CODE);
            } else{
                showToastMessage("PayAnywhere Sdk is not Installed. Plz Install PayAnywhere SDK");
            }
        }
    }

    public void recurringPaymentButtonClicked(View view) {
        String chargeAmount = mAmountEditText.getText().toString();
        String recurringPeriod = mRecurringPeriodSpinner.getSelectedItem().toString();
        String recurringLength = mRecurringLengthEditText.getText().toString();
        String recurringCustomerFirstName = mRecurringCustomerFirstEditText.getText().toString();
        String recurringCustomerLastName = mRecurringCustomerLastEditText.getText().toString();
        String recurringCustomerEmail = mRecurringCustomerEmailEditText.getText().toString();

        if(TextUtils.isEmpty(chargeAmount)){
            showToastMessage("Charge Amount is Empty");
        } else if(TextUtils.isEmpty(recurringPeriod)){
            showToastMessage("Recurring Period is Empty");
        } else if(TextUtils.isEmpty(recurringLength)){
            showToastMessage("Recurring Length is Empty");
        }   else {

            String intentUrl = PAYMENT_URL +  "?chargeAmount=" + chargeAmount
                    + "&recurringPeriod=" + recurringPeriod +
                    "&recurringLength=" + recurringLength;

            if(!TextUtils.isEmpty(recurringCustomerFirstName) &&
                    !TextUtils.isEmpty(recurringCustomerLastName) &&
                    !TextUtils.isEmpty(recurringCustomerEmail)){
                String recurringCustomerDetails = "&" +
                        EXTRA_FIRST_NAME + "=" + recurringCustomerFirstName + "&" +
                        EXTRA_LAST_NAME + "=" + recurringCustomerLastName + "&" +
                        EXTRA_EMAIL + "=" + recurringCustomerEmail;
                intentUrl += recurringCustomerDetails;
            }

            intentUrl += getOtherPaymentsParam();

            Intent intent = new Intent(Intent.ACTION_VIEW , Uri.parse(intentUrl));

            if(isPayAnywhereSdkInstalled(intent)){
                startActivityForResult(intent, PAYMENT_REQUEST_CODE);
            } else{
                showToastMessage("PayAnywhere Sdk is not Installed. Plz Install PayAnywhere SDK");
            }
        }
    }

    public void recurringPaymentUpdateButtonClicked(View view) {
        String recurringPaymentId = mRecurringIdEditText.getText().toString();
        String recurringCCSId = mRecurringCCSIdEditText.getText().toString();
        String recurringLength = mRecurringLengthEditText.getText().toString();
        String recurringPeriod = mRecurringPeriodSpinner.getSelectedItem().toString();
        if(TextUtils.isEmpty(recurringPaymentId)){
            showToastMessage("Recurring Payment Id Is Empty");
        } else if((TextUtils.isEmpty(recurringLength) && TextUtils.isEmpty(recurringPeriod)) && TextUtils.isEmpty(recurringCCSId)){
            showToastMessage("Either of Recurring Length and Period Or CCS ID is Required ");
        } else{
            StringBuilder paramBuilder = new StringBuilder();
            if(!TextUtils.isEmpty(recurringLength)){
                paramBuilder.append("&" + EXTRA_RECURRING_LENGTH + "=" + recurringLength);
            }
            if(!TextUtils.isEmpty(recurringPeriod)){
                paramBuilder.append("&" + EXTRA_RECURRING_PERIOD + "=" + recurringPeriod);
            }
            if(!TextUtils.isEmpty(recurringCCSId)){
                paramBuilder.append("&" + EXTRA_RECURRING_PAYMENT_CCS_ID + "=" + recurringCCSId);
            }
            String params = paramBuilder.toString();
            Intent intent = new Intent(Intent.ACTION_VIEW , Uri.parse(RECURRING_PAYMENT_UPDATE_URL +  "?" + EXTRA_RECURRING_PAYMENT_ID + "=" + recurringPaymentId + params + getOtherParams()));
            if(isPayAnywhereSdkInstalled(intent)){
                startActivityForResult(intent, RECURRING_PAYMENT_UPDATE_REQUEST_CODE);
            } else{
                showToastMessage("PayAnywhere Sdk is not Installed. Plz Install PayAnywhere SDK");
            }
        }
    }

    public void recurringPaymentDeactivateButtonClicked(View view) {
        String recurringPaymentId = mRecurringIdEditText.getText().toString();
        if(TextUtils.isEmpty(recurringPaymentId)){
            showToastMessage("Recurring Payment Id Is Empty");
        } else{
            Intent intent = new Intent(Intent.ACTION_VIEW , Uri.parse(RECURRING_PAYMENT_DEACTIVATE_URL +  "?" + EXTRA_RECURRING_PAYMENT_ID + "=" + recurringPaymentId + getOtherParams()));
            if(isPayAnywhereSdkInstalled(intent)){
                startActivityForResult(intent, RECURRING_PAYMENT_DEACTIVATE_REQUEST_CODE);
            } else{
                showToastMessage("PayAnywhere Sdk is not Installed. Plz Install PayAnywhere SDK");
            }
        }
    }

    public void refundButtonClicked(View view) {
        String transactionActionUniqueId = mTransactionActionUniqueIdEditText.getText().toString();
        String receiptId = mReceiptIdEditText.getText().toString();
        String refundAmount = mRefundAmountEditText.getText().toString();

        if(TextUtils.isEmpty(transactionActionUniqueId)){
            showToastMessage("Transaction ID cannot be empty");
        } else if(TextUtils.isEmpty(receiptId)){
            showToastMessage("Receipt ID cannot be empty");
        } else if(TextUtils.isEmpty(refundAmount)){
            showToastMessage("Refund Amount cannot be empty");
        } else{
            Intent intent = new Intent(Intent.ACTION_VIEW , Uri.parse(REFUND_URL +  "?transactionUniqueId=" + transactionActionUniqueId + "&receiptId=" + receiptId + "&refundAmount=" + refundAmount  + getOtherParams()));
            if(isPayAnywhereSdkInstalled(intent)){
                startActivityForResult(intent, REFUND_VOID_REQUEST_CODE);
            } else{
                showToastMessage("PayAnywhere Sdk is not Installed. Plz Install PayAnywhere SDK");
            }
        }
    }

    public void voidButtonClicked(View view) {
        String transactionActionUniqueId = mTransactionActionUniqueIdEditText.getText().toString();
        String receiptId = mReceiptIdEditText.getText().toString();
        if(TextUtils.isEmpty(transactionActionUniqueId)){
            showToastMessage("Transaction ID cannot be empty");
        } else if(TextUtils.isEmpty(receiptId)){
            showToastMessage("Receipt ID cannot be empty");
        } else{
            Intent intent = new Intent(Intent.ACTION_VIEW , Uri.parse(VOID_URL +  "?transactionUniqueId=" + transactionActionUniqueId + "&receiptId=" + receiptId + getOtherParams()));
            if(isPayAnywhereSdkInstalled(intent)){
                startActivityForResult(intent, REFUND_VOID_REQUEST_CODE);
            } else{
                showToastMessage("PayAnywhere Sdk is not Installed. Plz Install PayAnywhere SDK");
            }
        }
    }

    public void preAuthCompleteButtonClicked(View view) {
        String transactionActionUniqueId = mTransactionActionUniqueIdEditText.getText().toString();
        String receiptId = mReceiptIdEditText.getText().toString();
        String preAuthCompleteAmount = mPreAuthCompleteAmountEditText.getText().toString();
        if(TextUtils.isEmpty(transactionActionUniqueId)){
            showToastMessage("Transaction ID cannot be empty");
        } else if(TextUtils.isEmpty(receiptId)){
            showToastMessage("Receipt ID cannot be empty");
        } else if(TextUtils.isEmpty(preAuthCompleteAmount)){
            showToastMessage("PreAuth Complete Amount cannot be empty");
        } else{
            Intent intent = new Intent(Intent.ACTION_VIEW , Uri.parse(PREAUTH_COMPLETE_URL +  "?transactionUniqueId=" + transactionActionUniqueId + "&receiptId=" + receiptId + "&preAuthCompleteAmount=" + preAuthCompleteAmount  + getOtherParams()));
            if(isPayAnywhereSdkInstalled(intent)){
                startActivityForResult(intent, PREAUTH_COMPLETE_REQUEST_CODE);
            } else{
                showToastMessage("PayAnywhere Sdk is not Installed. Plz Install PayAnywhere SDK");
            }
        }
    }

    public void tipsButtonClicked(View view) {
        String transactionActionUniqueId = mTransactionActionUniqueIdEditText.getText().toString();
        String tipsAmount = mTipsAmountEditText.getText().toString();
        if(TextUtils.isEmpty(transactionActionUniqueId)){
            showToastMessage("Transaction ID cannot be empty");
        } else if(TextUtils.isEmpty(tipsAmount)){
            showToastMessage("Tips amount cannot be empty");
        } else{
            Intent intent = new Intent(Intent.ACTION_VIEW , Uri.parse(TIPS_URL +  "?transactionUniqueId=" + transactionActionUniqueId + "&tipsAmount=" + tipsAmount  + getOtherParams()));
            if(isPayAnywhereSdkInstalled(intent)){
                startActivityForResult(intent, TIPS_REQUEST_CODE);
            } else{
                showToastMessage("PayAnywhere Sdk is not Installed. Plz Install PayAnywhere SDK");
            }
        }
    }

    private String getOtherPaymentsParam(){
        StringBuilder paramsBuilder = new StringBuilder();
        if(!TextUtils.isEmpty(mItemNameEditText.getText().toString())){
            paramsBuilder.append(ITEM_NAME_PARAM + mItemNameEditText.getText().toString());
        }
        paramsBuilder.append(getOtherParams());
        return paramsBuilder.toString();
    }

    private String getOtherParams(){
        StringBuilder paramsBuilder = new StringBuilder();
        if(!TextUtils.isEmpty(mReceiptNotesET.getText().toString())) {
            paramsBuilder.append(RECEIPT_NOTES_PARAM + mReceiptNotesET.getText().toString());
        }
        if(mAllowCategoryCheckBox.isChecked()) {
            paramsBuilder.append(ALLOW_CATEGORY_PARAM + "true");
        }
        if(mSendBRICCheckBox.isChecked()) {
            paramsBuilder.append(SEND_BRIC_PARAM + "true");
        }
        if(mHideSendAsInvoiceCheckBox.isChecked()) {
            paramsBuilder.append(HIDE_SEND_AS_INVOICE_PARAM + "true");
        }
        if(mShowAcceptCashCheckBox.isChecked()) {
            paramsBuilder.append(SHOW_ACCEPT_CASH_PARAM + "true");
        }
        if(mShowAlipayCheckBox.isChecked()) {
            paramsBuilder.append(SHOW_ALIPAY_PARAM + "true");
        }
        if(mExternalNotificationCheckBox.isChecked()){
            paramsBuilder.append(EXTERNAL_NOTIFICATION_PARAM + "true");
        }
        if(mCancelNotificationCheckBox.isChecked()){
            paramsBuilder.append(CANCEL_NOTIFICATION_PARAM + "true");
        }
        if(mCloseSdkOnDeclineCheckBox.isChecked()){
            paramsBuilder.append(CLOSE_SDK_ON_DECLINE_PARAM + "true");
        }
        if(mReceiptScreenDisabledCheckBox.isChecked()){
            paramsBuilder.append(REQUIRED_RECEIPT_SCREEN_PARAM + "false");
        }
        if(mSignOnPrintReceiptCheckBox.isChecked()) {
            paramsBuilder.append(REQUIRED_SIGNATURE_ON_PAPER + "true");
        }
        if(mRequiredCardDetailsCheckBox.isChecked()){
            paramsBuilder.append(REQUIRED_CC_DETAILS_PARAM + "true");
        }
        if(mShowTransListCheckBox.isChecked()) {
            paramsBuilder.append(SHOW_TRANS_LIST_PARAM + "true");
        }
        if(mShowSignatureScreenCheckBox.isChecked()) {
            paramsBuilder.append(SHOW_SIGNATURE_SCREEN_PARAM + "true");
        }
        if(!TextUtils.isEmpty(mCustomerProvidedIdEditText.getText().toString())){
            paramsBuilder.append(CUSTOMER_PROVIDED_ID_PARAM + mCustomerProvidedIdEditText.getText().toString());
        }
        if(!TextUtils.isEmpty(mInvoiceNumberEditText.getText().toString())){
            paramsBuilder.append(INVOICE_NUMBER_PARAM + mInvoiceNumberEditText.getText().toString());
        }
        if(!TextUtils.isEmpty(mAutoCancelTimeoutEditText.getText().toString())){
            paramsBuilder.append(AUTO_CANCEL_TIMEOUT_PARAM + mAutoCancelTimeoutEditText.getText().toString());
        }
        if(!TextUtils.isEmpty(mPrimaryColorEditText.getText().toString())){
            paramsBuilder.append(PRIMARY_COLOR_PARAM + mPrimaryColorEditText.getText().toString());
        }
        if(!TextUtils.isEmpty(mContrastColorEditText.getText().toString())){
            paramsBuilder.append(CONTRAST_COLOR_PARAM + mContrastColorEditText.getText().toString());
        }
        return paramsBuilder.toString();
    }

    public void showToastMessage(String msg){
        Toast.makeText(this, msg, Toast.LENGTH_LONG).show();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        Log.d(TAG,"onActivityResult requestCode " + requestCode + " resultCode " + resultCode);
        if(requestCode == PAYMENT_REQUEST_CODE || requestCode == PREAUTH_REQUEST_CODE || requestCode == PREAUTH_COMPLETE_REQUEST_CODE || requestCode == REFUND_VOID_REQUEST_CODE || requestCode == TIPS_REQUEST_CODE || requestCode == RECURRING_PAYMENT_UPDATE_REQUEST_CODE || requestCode == RECURRING_PAYMENT_DEACTIVATE_REQUEST_CODE){
            if(resultCode == RESULT_OK){
                Log.d(TAG,"result ok");
                showTransactionResponses(requestCode, resultCode, data);
            } else if(resultCode == RESULT_CANCELED){
                Log.d(TAG,"result cancelled");
                showTransactionResponses(requestCode, resultCode, data);
            }
        }
    }

    private void showTransactionResponses(int requestCode, int resultCode, Intent data){
        if(data != null){
            mResponseEditText.setText("");
            StringBuilder responseString = new StringBuilder();
            String transactionResult = data.getStringExtra(EXTRA_TRANSACTION_RESULT);
            String transactionUniqueId = data.getStringExtra(EXTRA_TRANSACTION_UNIQUE_ID);
            long receiptId = data.getLongExtra(EXTRA_RECEIPT_ID, 0);
            String customerTransactionId = data.getStringExtra(EXTRA_CUSTOMER_TRANSACTION_ID);
            String transactionAction = data.getStringExtra(EXTRA_TRANSACTION_ACTION);
            String transactionStatusMessage = data.getStringExtra(EXTRA_TRANSACTION_STATUS_MESSAGE);
            boolean isPartialAuth = data.getBooleanExtra(EXTRA_PARTIAL_AUTH, false);
            String recurringPaymentId = data.getStringExtra(EXTRA_RECURRING_PAYMENT_ID);
            String recurringPaymentCCSId = data.getStringExtra(EXTRA_RECURRING_PAYMENT_CCS_ID);
            String recurringPeriod = data.getStringExtra(EXTRA_RECURRING_PERIOD);
            String recurringLength = data.getStringExtra(EXTRA_RECURRING_LENGTH);
            String network = data.getStringExtra(EXTRA_NETWORK);
            String last4 = data.getStringExtra(EXTRA_LAST4);
            String invoiceCustomerName = data.getStringExtra(EXTRA_CUSTOMER_NAME);
            String firstName = data.getStringExtra(EXTRA_FIRST_NAME);
            String lastName = data.getStringExtra(EXTRA_LAST_NAME);
            String email = data.getStringExtra(EXTRA_EMAIL);
            String phoneNumber = data.getStringExtra(EXTRA_PHONE_NUMBER);
            String invoiceNumber = data.getStringExtra(EXTRA_INVOICE_NUMBER);
            String invoiceDueDate = data.getStringExtra(EXTRA_INVOICE_DUE);
            String riStartDate = data.getStringExtra(EXTRA_RI_START_DATE);
            String riEndDate = data.getStringExtra(EXTRA_RI_END_DATE);
            String riLength = data.getStringExtra(EXTRA_RI_LENGTH);
            String riPeriod = data.getStringExtra(EXTRA_RI_PERIOD);
            String txnBRIC = data.getStringExtra(EXTRA_TRANSACTION_BRIC);
            String authCode = data.getStringExtra(EXTRA_AUTH_CODE);

            if(!TextUtils.isEmpty(transactionAction)){
                if(!TextUtils.isEmpty(riStartDate)) {
                    responseString.append("Action:" + getString(R.string.recurring_invoice) + "\n");
                } else if(!TextUtils.isEmpty(invoiceDueDate)) {
                    responseString.append("Action:" + getString(R.string.invoice) + "\n");
                } else {
                    responseString.append("Action:" + transactionAction + "\n");
                }
            }

            if(!TextUtils.isEmpty(transactionResult)){
                responseString.append("Result:" + transactionResult + "\n");
            }

            if(!TextUtils.isEmpty(transactionStatusMessage)){
                responseString.append("Status Message:" + transactionStatusMessage + "\n");
            }

            if(!TextUtils.isEmpty(transactionUniqueId)){
                responseString.append("Transaction Unique Id:" + transactionUniqueId + "\n");
                //for easy testing setting into ui
                mTransactionActionUniqueIdEditText.setText(transactionUniqueId);
            }

            if(receiptId != 0){
                responseString.append("Receipt Id:" + receiptId + "\n");
                //for easy testing setting into ui
                mReceiptIdEditText.setText(receiptId + "");
            }

            if(!TextUtils.isEmpty(customerTransactionId)){
                responseString.append("Customer Trans Id:" + customerTransactionId + "\n");
            }

            BigDecimal requestedAmount = null;
            if(data.getSerializableExtra(EXTRA_REQUESTED_AMOUNT) != null){
                requestedAmount = (BigDecimal)data.getSerializableExtra(EXTRA_REQUESTED_AMOUNT);
            }
            if(requestedAmount != null){
                responseString.append("Requested Amount:" + requestedAmount + "\n");
                //for easy testing
                mRefundAmountEditText.setText(requestedAmount + "");
                mPreAuthCompleteAmountEditText.setText(requestedAmount + "");
            }

            BigDecimal authorizedAmount = null;
            if(data.getSerializableExtra(EXTRA_AUTHORIZED_AMOUNT) != null){
                authorizedAmount = (BigDecimal)data.getSerializableExtra(EXTRA_AUTHORIZED_AMOUNT);
            }
            if(authorizedAmount != null){
                responseString.append("Authorized Amount:" + authorizedAmount + "\n");
                //for easy testing
                mRefundAmountEditText.setText(authorizedAmount + "");
                mPreAuthCompleteAmountEditText.setText(authorizedAmount + "");
            }

            if(!TextUtils.isEmpty(txnBRIC)) {
                responseString.append("Transaction BRIC:" + txnBRIC + "\n");
            }

            if(!TextUtils.isEmpty(authCode)) {
                responseString.append("Auth Code:" + authCode + "\n");
            }

            if(!TextUtils.isEmpty(recurringPaymentId)){
                responseString.append("Recurring Payment Id:" + recurringPaymentId + "\n");
                //for easy testing
                mRecurringIdEditText.setText(recurringPaymentId + "");
            }

            if(!TextUtils.isEmpty(recurringPaymentCCSId)){
                responseString.append("Recurring Payment CCS Id:" + recurringPaymentCCSId + "\n");
            }

            if(!TextUtils.isEmpty(recurringPeriod)){
                responseString.append("Recurring Period:" + recurringPeriod + "\n");
            }

            if(!TextUtils.isEmpty(recurringLength)){
                responseString.append("Recurring Length:" + recurringLength + "\n");
            }

            if(isPartialAuth){
                responseString.append("PartialAuth:True" + "\n");
            }

            if(!TextUtils.isEmpty(firstName)){
                responseString.append("First Name:" + firstName + "\n");
            }

            if(!TextUtils.isEmpty(lastName)){
                responseString.append("Last Name:" + lastName + "\n");
            }

            if(!TextUtils.isEmpty(network)){
                responseString.append("Network:" + network + "\n");
            }

            if(!TextUtils.isEmpty(last4)){
                responseString.append("Last4:" + last4 + "\n");
            }

            if(!TextUtils.isEmpty(invoiceCustomerName)) {
                responseString.append("Customer Name:" + invoiceCustomerName + "\n");
            }

            if(!TextUtils.isEmpty(email)) {
                responseString.append("Email:" + email + "\n");
            }

            if(!TextUtils.isEmpty(phoneNumber)) {
                responseString.append("Phone Number:" + phoneNumber + "\n");
            }

            if(!TextUtils.isEmpty(invoiceNumber)) {
                responseString.append("Invoice Number:" + invoiceNumber + "\n");
            }

            if(!TextUtils.isEmpty(invoiceDueDate)) {
                responseString.append("Invoice Due Date" + invoiceDueDate + "\n");
            }

            if(!TextUtils.isEmpty(riStartDate)) {
                responseString.append("Recurring Invoice Start Date:" + riStartDate + "\n");
                if(!TextUtils.isEmpty(riEndDate)) {
                    responseString.append("Recurring Invoice End Date:" + riEndDate + "\n");
                }
                if(!TextUtils.isEmpty(riLength)) {
                    responseString.append("Recurring Invoice Length:" + riLength + "\n");
                }

                if(!TextUtils.isEmpty(riPeriod)) {
                    responseString.append("Recurring Invoice Period:" + riPeriod + "\n");
                }
            }

            Log.d(TAG,transactionResult + " uniqueId " + transactionUniqueId + " customerTransactionId " + customerTransactionId + " isPartialAuth " + isPartialAuth + " requestedAmount " + requestedAmount +" authorizedAmount " + authorizedAmount);

            mResponseEditText.setText(responseString);
        } else{
            mResponseEditText.setText("");
        }
    }

    private boolean isPayAnywhereSdkInstalled(Intent intent){
        PackageManager packageManager = getPackageManager();
        if (intent != null && intent.resolveActivity(packageManager) != null) {
            return true;
        } else {
            return false;
        }
    }
}
